// CPSS_SMS.cpp : main source file for CPSS_SMS.exe
//

#include "stdafx.h"

#include <atlframe.h>
#include <atlctrls.h>
#include <atldlgs.h>
#include "resource.h"
//#include "aboutdlg.h"
#include "PowerMgmt.h"

#include "publicCtrl.h"
#include "configdlg.h"
//#include "MenuClient.h"
//#include "MsgView.h"
#define COINIT_MULTITHREADED 0
#include <objbase.h>
extern void handle5sLeave( HWND);
#include "tempLocale.h"
CAppModule    _Module;
#include "jansson.h"
#include "running.h"
#include "listbox.h"
#include "cpss_messageSend.h"
#define BOARD_INC 1
#if BOARD_INC
//#include "cn828_board.h"
#endif
extern void StartThread(void);
TCHAR* IncommingPop(TCHAR*);
static const TCHAR *szWindowClass = _T("JOB_LISTENER");

BOOL init_reg();

HANDLE ghEventExit=NULL;
HANDLE ghEventMsg=NULL,ghEventCfg=NULL,ghEventExistCfg=NULL,ghEventExistCfgYes=NULL,ghEventChangeSkin=NULL;
HANDLE ghEventPopDelay=NULL,ghEventPopDelayCancel=NULL;
HWND g_hWndListen = NULL;
static TCHAR  szEventMsg[]=L"Event.JobMan";
static TCHAR  szEventExit[]=L"Event.JobExit";
static TCHAR  szEventCfg[]=L"job.config";
static TCHAR  szEventExistCfg[]=L"job.existconfig";
static TCHAR  szEventExistCfgYes[]=L"job.existconfigyes";
static TCHAR  szEventPopDelay[]=L"job.popdelay";
static TCHAR  szEventPopDelayCancel[]=L"job.popdelaycancel";
static TCHAR  szEventChangeSkin[]=L"ChangeSkin";

static HANDLE ghDaemonThread = NULL,ghTimerThread=NULL;
static DWORD WINAPI DaemonTask2(void*para );
static BOOL bShowWindow = FALSE;
static DWORD WINAPI TimerTask(void*para );
static DWORD WINAPI BTHTask(void*para );
HANDLE ghMutex=0;
extern int g_bMasterDat;
extern TCHAR g_szJobDir[64];
extern DWORD g_dwCheckTimer,g_dwAlarm;
extern BOOL g_bAutoClose;
BOOL g_bPopDelay = 0;
TCHAR* g_pszFileDelay =NULL;
BOOL g_SDCardChanged = 1;
extern CSimpleArray<SavedNaviRecord_t> g_listJobSaved;
void check_position(HWND);
void check_duetime();
void ShowStatusPopup(int i);
int g_bSDCardStatus= SD_UNKNOWN;
static CpssListBox* pListWnd=0;
 void MonitorContainer(HWND);
void initContainerMap();
void saveContainerMap();

static void CheckFlashJobFolder()
{
	DWORD err = GetFileAttributes(g_szJobDir);

	if( INVALID_FILE_ATTRIBUTES==err || !(err&FILE_ATTRIBUTE_DIRECTORY))
	//if(!PathFileExists(g_szJobDir))
	{
		CreateDirectory( g_szJobDir ,NULL);
	}
}
static int __move_file(CString strSrc,CString strDest)
{

	BOOL bOK = MoveFile(strSrc,strDest);
	if(!bOK)
	{
		DWORD err = GetLastError();
		DeleteFile(strDest);
		bOK= MoveFile(strSrc,strDest);
		if(!bOK)
		{
			err = GetLastError();
			if(g_bMasterDat)
			{
				
				/*MessageBox(NULL,L"Can not write to SDCard, Please try to reinsert the SDCard!",L"Warnning",MB_OK);

		     	int nCount=10;
				ULARGE_INTEGER uFree,uTotal,uFreeTotal;
				
				while(!GetDiskFreeSpaceEx(L"\\Storage Card",&uFree,&uTotal,&uFreeTotal))
				{
					if(!nCount--) break;
					Sleep(500);
				}*/
				return -1;
			}
		}
	}
	return 0;
}
int IncommingDelPop(TCHAR*) ;
void DeleteJobWithID(TCHAR * jobid);
 TCHAR* SaveJobToFlashDisk(TCHAR* tmpPath){
	WIN32_FIND_DATA fndData;
	HANDLE hFind;
	CString strDest,strSrc,strFind;
	int count=0;
	TCHAR * pszFile= 0;
	__LOCK__();
	CheckFlashJobFolder();
	strFind.Format(L"%s\\%s",tmpPath,JOBFILE_EXT);
	hFind = FindFirstFile(strFind, &fndData);	
	int len=0;
	if (INVALID_HANDLE_VALUE != hFind) 	
	{
		//*FileName = fndData.cFileName;	//oɦW
		
		do
		{	
			
			if(g_SDCardChanged)
			{
				initINIFlag();
			}
			TCHAR* pn = wcsrchr(fndData.cFileName,TCHAR('.'));
			if(pn==NULL) pn = fndData.cFileName;
			if(wcsstr(pn,L".jo3") || wcsstr(pn,L".jo4")|| wcsicmp(pn,L".job")==0 )
			{
				strDest.Format(L"%s\\%s",g_szJobDir,fndData.cFileName);
				strSrc.Format(L"%s\\%s",tmpPath,fndData.cFileName);
				if(-1==__move_file(strSrc,strDest)) 
				{
					if(g_bMasterDat) 
					{
						initINIFlag();
						if(-1==__move_file(strSrc,strDest))
							break;
					}
					//break;
				}
				count++;
				//wcscpy(g_szJobFile,strDest);
				if(!pszFile)
				{
					len = strDest.GetLength()+2;
					pszFile = new TCHAR [len] ;
					memset(pszFile,0,len*2);
					wcscpy(pszFile,(LPCTSTR)strDest);
				}else
				{
					int newlen = len+strDest.GetLength()+1;
					TCHAR* p = new TCHAR[newlen];
					memset(p,0,newlen*2);
					wcscpy(p,(LPCTSTR)strDest);
					memcpy((p+strDest.GetLength()+1),pszFile,len*2);
					delete pszFile;
					pszFile= p;
					len = newlen;
				}
			}else if(wcsstr(fndData.cFileName,L".jobdel") ) // delete file <jobid:=UUID><action:=delete>		//change .job to .jobdel according to sascha on 2011/5/6			
			{ 
				//delete job
				if(wcsicmp(fndData.cFileName,L"reset.jobdel")==0)
				{
					PurgeAll();
				}else{
					strSrc.Format(L"%s\\%s",tmpPath,fndData.cFileName);
					char wcsPath[128], *mbstr=NULL;
					wcstombs(wcsPath,(LPCTSTR)strSrc,strSrc.GetLength()+1);
					FILE *f  =fopen(wcsPath,"rt");
					if(f)
					{
						int err = 0;
						int maxlen;
						fseek(f,0,SEEK_END);
						maxlen = ftell(f);
						fseek(f,0,SEEK_SET);
						mbstr = (char*)malloc(maxlen+1);
						memset(mbstr,0,maxlen);
						char*p = mbstr;
						fread(mbstr,1,maxlen,f);//fgets(mbstr,255,f);
						char *szjob,szact[64];
						if(p)
						{
							char* p2,*p1 = strstr(p,"<jobid:=");
							if(p1)
							{
								p1+= strlen("<jobid:=");
								p2 = strchr(p1,'>');
								if(p2)
								{
									*p2=0;
									szjob= (char*)malloc(strlen(p1)+1);
									strcpy(szjob,p1);
									p=p2+1;
									p1= strstr(p,"<action:=");
									if(p1)
									{
										p1+= strlen("<action:=");
										p2 = strchr(p1,'>');
										if(p2)
										{
											*p2=0;
											strcpy(szact,p1);
										}else 
											err=1;
									}else err=1;

								}else
								{
									err = 1;
								}
							}

						}
						if(mbstr) free(mbstr);
						if(err==0 && _stricmp(szact,"delete")==0)
						{
							TCHAR* wcsjob=0;
							wcsjob =(TCHAR*) malloc( strlen(szjob)*2+2);

							mbstowcs(wcsjob,szjob,strlen(szjob)+1);
							//if(IncommingDelPop(wcsjob) == TRUE)
							{
								free(szjob);
								DeleteJobWithID(wcsjob);
								free(wcsjob);
								/*if(pListWnd && pListWnd->IsWindow())
								{
									BOOL bHandle=0;
									pListWnd->OnUserUpdateList(USER_REFRESH_ALL,0,0,bHandle);
									//UINT nItem = (UINT)lParam;
									//pListWnd->OnUserUpdateList(USER_DEL_ITEM,-1,nItem,bHandle);
								}*/
							}
						}
						
						fclose(f);
						DeleteFile(strSrc); 
						
					}
				}
			}
		} while(FindNextFile(hFind, &fndData));
		FindClose(hFind);
	}
	strFind.Format(L"%s\\%s",tmpPath,L"*.bc*");
	hFind = FindFirstFile(strFind, &fndData);	
	if (INVALID_HANDLE_VALUE != hFind) 	
	{
		//*FileName = fndData.cFileName;	//oɦW
		//int len=0;
		do
		{	
			if(g_SDCardChanged)
			{
				initINIFlag();
			}

			if(wcsstr(fndData.cFileName,L".bc3") )
			{
				strDest.Format(L"%s\\%s",g_szJobDir,fndData.cFileName);
				strSrc.Format(L"%s\\%s",tmpPath,fndData.cFileName);
				if(-1==__move_file(strSrc,strDest)) 
				{
					if(g_bMasterDat) 
					{
						initINIFlag();
						if(-1==__move_file(strSrc,strDest))
							break;
					}
					//break;
				}
				count++;
				//wcscpy(g_szJobFile,strDest);
				if(!pszFile)
				{
					len = strDest.GetLength()+2;
					pszFile = new TCHAR [len] ;
					memset(pszFile,0,len*2);
					wcscpy(pszFile,(LPCTSTR)strDest);
				}else
				{
					int newlen = len+strDest.GetLength()+1;
					TCHAR* p = new TCHAR[newlen];
					memset(p,0,newlen*2);
					wcscpy(p,(LPCTSTR)strDest);
					memcpy((p+strDest.GetLength()+1),pszFile,len*2);
					delete pszFile;
					pszFile= p;
					len = newlen;
				}
			}
		} while(FindNextFile(hFind, &fndData));
		FindClose(hFind);
	}
	__unLOCK__();
	return pszFile;
}
void initJobState();
void clearJobState();
 void SendGPSInfo();
void initConfig();
void saveConfig();
extern BOOL g_bOpenList ;



#include <dbt.h>
  CpssListBox* GetMainListBox()
  {
	  if(pListWnd && pListWnd->IsWindow())
		 return pListWnd;
	  else return NULL;
  }
void ShowCfgWnd()
{

	static CConfigDlg*  pCfgWnd =0;
	if(pCfgWnd && IsWindow(pCfgWnd->m_hWnd))
		pCfgWnd->BringWindowToTop();
	else{
		int nRet;
		pCfgWnd = new CConfigDlg(NULL,0);
		nRet = pCfgWnd->DoModal();
		delete pCfgWnd;pCfgWnd=0;
		if(nRet)
		{
			if(pListWnd&&pListWnd->IsWindow())
			{
				BOOL bHandle=0;
				pListWnd->OnUserUpdateList(USER_CFG_CHANGED,0,0,bHandle);
			}
		}

	} 
}
#define POS_CHECK_INTERVAL 3
LRESULT CALLBACK JobWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  DWORD dwID;
  static int nTimer=-1 , n1mTimer=-1,m_nGeoTimer=-1,m_nSciTimer=-1;
   

  LRESULT  ret =  DefWindowProc(hWnd, message, wParam, lParam);
  if(message==WM_CREATE)
  {
	 StartPowerManagement();
	 SetRunningStatus("job", TRUE);
	 initINIFlag();
	 initConfig();
	 ghEventExit = CreateEvent(NULL,TRUE,FALSE,szEventExit);
	 ghEventMsg = CreateEvent(NULL,FALSE,FALSE,szEventMsg);
	  ghEventCfg = CreateEvent(NULL,FALSE,FALSE,szEventCfg);
	 ghEventExistCfg = CreateEvent(NULL,FALSE,FALSE,szEventExistCfg);
	 ghEventExistCfgYes = CreateEvent(NULL,FALSE,FALSE,szEventExistCfgYes);
	 ghEventChangeSkin= CreateEvent(NULL,FALSE,FALSE,szEventChangeSkin);
	 SetEvent(ghEventExistCfgYes);

     ghEventPopDelay = CreateEvent(NULL,FALSE,FALSE,szEventPopDelay);
	 ghEventPopDelayCancel = CreateEvent(NULL,FALSE,FALSE,szEventPopDelayCancel);

	 StartSoundTask();
	 ghMutex = CreateMutex(NULL,FALSE,NULL);
	 ghDaemonThread = CreateThread(NULL,0 , DaemonTask2 ,(void*)hWnd,0, &dwID);	
	 ghTimerThread = CreateThread(NULL,0 , TimerTask ,(void*)hWnd,0, &dwID);	
	 CreateThread(NULL,0 , BTHTask ,(void*)hWnd,0, &dwID);	
	// initJobState();
	 initContainerMap();
	 nTimer = SetTimer(hWnd,0x55,1000*POS_CHECK_INTERVAL,NULL); // SetTimer(hWnd,0x55,1000*15,NULL); 
	 n1mTimer = SetTimer(hWnd,0x56,1000*40,NULL); // 1 min timer
	 m_nGeoTimer = SetTimer(hWnd, 0x88,3000,NULL);
	 m_nSciTimer = SetTimer(hWnd, 0x77,20000,NULL); // check sci file , 20 sec
	// ShowCfgWnd();
	 InitCached_Images();


	 if(bShowWindow)
	 {
		 PostMessage(hWnd,WM_USER_INDICATE,0,0);
	 }
	 
  }else if(message==WM_DEVICECHANGE)
  {
  	if(wParam==DBT_DEVNODES_CHANGED){
		//bHandled = 0;
	}else if(wParam == DBT_DEVICEARRIVAL)
	{
		PDEV_BROADCAST_HDR pdev = (PDEV_BROADCAST_HDR)lParam;
		if(pdev && pdev->dbch_devicetype==DBT_DEVTYP_PORT)
		{
			PDEV_BROADCAST_PORT pPort = (PDEV_BROADCAST_PORT)lParam;
			if(memcmp( (BYTE*)pPort->dbcp_name,L"DSK1:",6)==0){
				g_SDCardChanged=1;//initINIFlag();
				g_bSDCardStatus= SD_INSERTED;
			}else {
			//	errLog("Other USB device Plug In\r\n");
			}
		}
	}else if(wParam == DBT_DEVICEREMOVECOMPLETE){
		PDEV_BROADCAST_HDR pdev = (PDEV_BROADCAST_HDR)lParam;
		if(pdev && pdev->dbch_devicetype==DBT_DEVTYP_PORT)
		{
			PDEV_BROADCAST_PORT pPort = (PDEV_BROADCAST_PORT)lParam;
			if(memcmp( (BYTE*)pPort->dbcp_name,L"DSK1:",6)==0){
				g_SDCardChanged = 1; //initINIFlag();
				g_bSDCardStatus= SD_REMOVED;
				g_listJobSaved.RemoveAll();
			}else {
			//	errLog("Other USB device Plug In\r\n");
			}
			
		}
	}
  
  }else if(message==WM_DESTROY)
  {
	  if(nTimer!=-1) KillTimer(hWnd,nTimer);
	  if(n1mTimer!=-1) KillTimer(hWnd,n1mTimer);
	  if(m_nGeoTimer!=-1) KillTimer(hWnd,m_nGeoTimer); 
	  SetEvent(ghEventExit);
	  WaitForSingleObject(ghDaemonThread,2000);
	  WaitForSingleObject(ghTimerThread,12000);
	  CloseHandle(ghEventExit);
	  CloseHandle(ghEventMsg);CloseHandle(ghEventCfg);
	  CloseHandle(ghMutex);ghMutex=0;
	  CloseHandle(ghEventExistCfg);
	  CloseHandle(ghEventExistCfgYes);
	   CloseHandle(ghEventPopDelay);
	  CloseHandle(ghEventPopDelayCancel);
	   CloseHandle(ghEventChangeSkin);
	  if( ghEventPopup )  CloseHandle(ghEventPopup);
	  SetRunningStatus("job", FALSE);
	  clearJobState();
	  saveContainerMap();
	  StopPowerManagement();
	  PostQuitMessage(0);
	  
  }/*else if(WM_ACTIVATE==message)
  {
	  int act = LOWORD(wParam);
	  if (act!=WA_INACTIVE)
		SetWindowPos(hWnd,HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
	  else
		SetWindowPos(hWnd,HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
	  MessageBox(hWnd,L"dfdd",L"dd",MB_OK);
  }*/
  else if(WM_USER_INDICATE==message)
  {
	  if(wParam==1){ // open popup and add incommning job
		  TCHAR* pszFile = (TCHAR*) lParam;
		  TCHAR* pOutFiles=0;
		  if(g_dwMode==0)
		  {
			  if( (pOutFiles=IncommingPop( pszFile ))){
				  if(pListWnd&&pListWnd->IsWindow()) // if (list box opened )
				  {
						//pListWnd->SendMessage(hWnd, WM_USER_UPDATE_LIST,0,(LPARAM)pszFile);
					  BOOL bRet=0;
					  pListWnd->OnUserUpdateList(USER_UPDATE_LIST,-1,(LPARAM)pOutFiles,bRet);
					  
				  }else if( g_bOpenList)
				  {
					  PostMessage( hWnd, WM_USER_INDICATE,0,0);	
				  }
				  free(pOutFiles);
			  }else 
			  {
					g_pszFileDelay = pszFile;
					return ret;
			  }
		  }else
		  {
				if(pListWnd&&pListWnd->IsWindow()) // if (list box opened )
				  {
						//pListWnd->SendMessage(hWnd, WM_USER_UPDATE_LIST,0,(LPARAM)pszFile);
					  BOOL bRet=0;
					  pListWnd->OnUserUpdateList(USER_UPDATE_LIST,-1,(LPARAM)pszFile,bRet);
					  
				  }	
		  }
		  delete pszFile;
		  g_pszFileDelay = NULL;	
	  
	  }else if(wParam==0){ // open listbox or config dialog
		  if(lParam==0){
			  if(!pListWnd || !IsWindow(pListWnd->m_hWnd)  )
			  {
				  if(pListWnd) delete pListWnd;
				  pListWnd = new CpssListBox(NULL, SET_SMS,0);
				  pListWnd->Create(NULL);//pListWnd->DoModal();
				  pListWnd->ShowWindow(SW_SHOW);//delete pListWnd;pListWnd=0;
			  }else
			  {
				    HWND hWnd = pListWnd->m_hWnd;
					BOOL bOK = SetForegroundWindow(hWnd);
					if(!bOK){
						//bOK = ::SetForegroundWindow((HWND(wParam));
						hWnd = FindWindow(_T("JOB_LISTENER"),NULL);
						bOK = ::SetForegroundWindow(hWnd);
					}
					ShowWindow(hWnd,SW_SHOW);
					__set_pre_window_handle__(hWnd);	
					
			  }
		  }else if(lParam==1)
		  {
			  ShowCfgWnd();
		   }
			
	  }else if(wParam==2){  // delete item
		  BOOL bRet=0;
		  UINT nItem = (UINT)lParam;
		  pListWnd->OnUserUpdateList(USER_DEL_ITEM,-1,nItem,bRet);
	  }else if(wParam==3){  // update item
		  BOOL bRet=0;
		  UINT nItem = (UINT)lParam;
		  pListWnd->OnUserUpdateList(USER_REFRESH_ITEM,-1,nItem,bRet);
	  }
  }else if(message==WM_TIMER)
  {
	  if(wParam==0x55)
	  {
		if(g_dwAlarm ) check_position(hWnd);
	  }else  if(wParam==0x56) // 1m timer
	  {
		 //RegisterClient();
		check_duetime();
	  }else if(wParam==0x3000) // 5s timer for leave radius
	  {
		  handle5sLeave( hWnd);
	  }else if(wParam==0x77) // 20s timer for sci file check
	  {
		  MonitorContainer( hWnd);
	  }else {
		
		  handle_geo_update( hWnd,wParam,szWindowClass);
	  }
  }else if(message==WM_USER_CHANGE_SKIN && wParam==0)
  {
		ChangeSkin();	
		SendMessage(HWND_BROADCAST ,WM_USER_CHANGE_SKIN,1,0);
  } else if(message==WM_JSON_NOTIFY && lParam==WM_JSON_LPARAM){
		int idx = wParam;
		void check_for_bth(int idx);
		check_for_bth(idx);
  }else{

	   handle_menu_message( hWnd,message,  wParam,  lParam);
  
  }
  return ret;
}
void RegisterClass()
{
  WNDCLASS wcex;
  
  HANDLE module = GetModuleHandle(NULL);
  
  memset(&wcex, 0, sizeof(wcex));
  wcex.lpfnWndProc       = (WNDPROC) JobWndProc;
  wcex.lpszClassName     = szWindowClass;
  
  RegisterClass(&wcex);
}

BOOL  CreateListenerWindow()
{
  HWND hWnd = FindWindow(szWindowClass,NULL);
  if(hWnd){
	 // MessageBox(hWnd,L"Job Manager is already running!",L"Job Manager",MB_OK);
	  return FALSE;
  }
  RegisterClass();
  
  hWnd = CreateWindow(szWindowClass,
                           szWindowClass,
                           0,
                           0,40,SCREEN_W,SCREEN_H-40,
                           NULL,
                           NULL,
                           NULL,
                           NULL);
  g_hWndListen = hWnd;
  DWORD dwStyle = GetWindowLong(g_hWndListen,GWL_STYLE);
  dwStyle &= ~ (WS_CAPTION |WS_BORDER   ) ;
  SetWindowLong(g_hWndListen,GWL_STYLE,dwStyle);

  //RECT rect;
  //GetWindowRect(hWnd, &rect);
	return TRUE;                           
}
#if 0
static DWORD WINAPI DaemonTask(void*para )
{
	//write reset command to IN folder
	//wait for back
	//get data.
	HWND hWnd = (HWND) para;
	TCHAR wcPath[64],tmpPath[64];
DWORD fMask = 0xFF;
	mbstowcs(wcPath,DATA_IN_PATH,strlen(DATA_IN_PATH)+1);
	wsprintf(tmpPath,TEXT("%s\\%s"),wcPath,JOBFILE_EXT);
	HANDLE handles[4];
	HANDLE hChange = FindFirstChangeNotification(wcPath,
		FALSE,fMask);
	DWORD ret = 0;
	TCHAR *pszFile=0;
	while(hChange!=(HANDLE)-1){
		//ret = WaitForSingleObject(hChange,-1);
		handles[3]=ghEventCfg;
		handles[2]=ghEventExit;
		handles[1]=ghEventMsg;
		handles[0]=hChange;
		ret = WaitForMultipleObjects(4, handles,FALSE,INFINITE);
		if(ret==WAIT_OBJECT_0){
			/*WIN32_FIND_DATA fndData;
			HANDLE hFind;
			hFind = FindFirstFile(tmpPath, &fndData);	

			
			if (INVALID_HANDLE_VALUE != hFind) 	
			{
				//*FileName = fndData.cFileName;	//oɦW
				PostMessage( hWnd, WM_USER_INDICATE,1,0);
				FindClose(hFind);
			}*/
			if( (pszFile=SaveJobToFlashDisk(wcPath))!=0)
				PostMessage( hWnd, WM_USER_INDICATE,1,(LPARAM) pszFile);

			if(!FindNextChangeNotification(hChange))
			{
			//	PostMessage( hWnd, WM_USER_INDICATE,0,0);
				break;
			}
		
		}else if(ret==WAIT_OBJECT_0+1){
			//open joblist windows
			PostMessage( hWnd, WM_USER_INDICATE,0,0);
			//break;
		}else if(ret==WAIT_OBJECT_0+3){
			//open cfg windows
			PostMessage( hWnd, WM_USER_INDICATE,0,1);
			//break;
		}else if(ret==WAIT_OBJECT_0+2){
			PostMessage(hWnd,WM_CLOSE,0,0);			
			break;
		}else break;
	}
	if(hChange!=(HANDLE)-1) FindCloseChangeNotification(hChange);
	
	return 0;
}
#endif
static DWORD WINAPI DaemonTask2(void*para )
{
	//write reset command to IN folder
	//wait for back
	//get data.
	HWND hWnd = (HWND) para;
	TCHAR tmpPath[64];
DWORD fMask = 0xFF;
	TCHAR * wcPath = _T(DATA_IN_PATH) ; //mbstowcs(wcPath,DATA_IN_PATH,strlen(DATA_IN_PATH)+1);
	wsprintf(tmpPath,TEXT("%s\\%s"),wcPath,JOBFILE_EXT);
	HANDLE handles[7];
//	HANDLE hChange = FindFirstChangeNotification(wcPath,FALSE,fMask);
	DWORD ret = 0;
	int timeout =g_dwCheckTimer;
	TCHAR *pszFile=0;
	SYSTEMTIME localTime;
	GetLocalTime(&localTime);
	__ALARM_LOG__("Started on %d/%02d/%02d %02d:%02d\n",localTime.wYear,localTime.wMonth,localTime.wDay,localTime.wHour,localTime.wMinute);
	
static TCHAR  szEventReady[]=L"Job.Ready";
	HANDLE hEventTaskReady=CreateEvent(NULL,TRUE,FALSE,szEventReady);
	if(hEventTaskReady) SetEvent(hEventTaskReady);	
	while(1){
		//ret = WaitForSingleObject(hChange,-1);
		
		handles[0]=ghEventMsg;
		handles[1]=ghEventExit;
		handles[2]=ghEventCfg;
		handles[3]=ghEventExistCfg;
		handles[4] = ghEventPopDelay;
		handles[5] = ghEventPopDelayCancel;
		//handles[6] = ghEventChangeSkin;
		ret = WaitForMultipleObjects(6, handles,FALSE,timeout);
		if(ret==WAIT_OBJECT_0){
			//open windows
			PostMessage( hWnd, WM_USER_INDICATE,0,0);
			//break;
		}else if(ret==WAIT_OBJECT_0+1){
			__ALARM_LOG__("exit by event \n");
			/* HWND hWnd = FindWindow(szWindowClass,NULL);
			::SetWindowPos(hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE);
			MessageBox(hWnd,L"I am closed by exit event from MENU!",L"JobApp",MB_OK);
			*/
			PostMessage(hWnd,WM_CLOSE,0,0);	

			break;
		}else if(ret==WAIT_OBJECT_0+2){  //open cfg window
			PostMessage( hWnd, WM_USER_INDICATE,0,1);
			
		}else if(ret==WAIT_OBJECT_0+3){  //query existcfg
			SetEvent(ghEventExistCfgYes);
			
		}else if(ret==WAIT_OBJECT_0+4)
		{
			g_bPopDelay=TRUE;
		}else if(ret==WAIT_OBJECT_0+5)
		{
			g_bPopDelay=FALSE;
			if(g_pszFileDelay) 
			{
				PostMessage( hWnd, WM_USER_INDICATE,1,(LPARAM) g_pszFileDelay);
			}
		}else  if(ret==WAIT_OBJECT_0+6){  //query existcfg
			//SetEvent(ghEventExistCfgYes);
			PostMessage( hWnd, WM_USER_CHANGE_SKIN,0,0);
		}else 
		{
			if(!g_bPopDelay)
			{
				if( (pszFile=SaveJobToFlashDisk(wcPath))!=0)
					PostMessage( hWnd, WM_USER_INDICATE,1,(LPARAM) pszFile);
			}
		}
	}
	//if(hChange!=(HANDLE)-1) FindCloseChangeNotification(hChange);
	
	return 0;
}
int Run(LPTSTR lpstrCmdLine = NULL, int nCmdShow = SW_SHOWNORMAL)
{
	int nRet;
	BOOL bVU=TRUE;
	BOOL bBoard=FALSE;

#define Menu_Major 2010
#define Menu_Extend1 7
#define Menu_Extend2 8
	if(lpstrCmdLine && ::_wtoi(lpstrCmdLine) == 99 )
	{
		nRet=(Menu_Major<<16)|(Menu_Extend1<<8)|(Menu_Extend2);
	 
		return nRet;
	}
	SET_SKIN_HANDLE(lpstrCmdLine) 
	if( NULL!=wcsstr( lpstrCmdLine,L"-show=1") )
		bShowWindow=TRUE;
    CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);
	HINSTANCE hInst=_Module.GetModuleInstance();
	HINSTANCE hRes = SetDefaultLang(L"CN828Job" , lpstrCmdLine);
	if(hRes)
		_Module.SetResourceInstance(hRes);
	init_reg();

/*
	HWND htaskbar = ::FindWindow(TEXT("HHTaskBar"),NULL);
#ifdef _DEBUG
	if (NULL != htaskbar) { ::ShowWindow(htaskbar,SW_SHOW); }
#else
	if (NULL != htaskbar) { ::ShowWindow(htaskbar,SW_HIDE); }
#endif
*/
	if (*lpstrCmdLine!=0)
	{
		bVU = FALSE;
#if BOARD_INC
		if( wcscmp(lpstrCmdLine,L"-b")==0) bBoard = TRUE;
#endif
	}

if(!CreateListenerWindow()) return 0;

//Tell Menu, that I am here - and tell the HWND of the Listener-Window
  HWND hWnd = FindWindow(szWindowClass,NULL);
  if(hWnd){
	  ::SendNotifyMessage(HWND_BROADCAST,USER_JOBAPP_CLIENT_HELLO,(WPARAM) hWnd,0);
  }
g_hWndListen = hWnd;

nRet = theLoop.Run();
#ifdef __PNG_CACHE__
	PNGCache_Clear();
#endif
	ClearObjects();
FREE_SKIN_HANDLE()
	//uC
	//htaskbar = ::FindWindow(TEXT("HHTaskBar"),NULL);
	//if (NULL != htaskbar) { ::ShowWindow(htaskbar,SW_SHOW); }
//	if(::_wtoi(lpstrCmdLine) != 99) 
//		_TerminalMenuClient();//Off Line
	_Module.RemoveMessageLoop();
	return nRet;
}
WINOLEAPI  CoInitializeEx(IN LPVOID pvReserved, IN DWORD dwCoInit);
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes = CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

	// Calling AtlInitCommonControls is not necessary to utilize picture,
	// static text, edit box, group box, button, check box, radio button, 
	// combo box, list box, or the horizontal and vertical scroll bars.
	// Calling AtlInitCommonControls with 0 is required to utilize the spin, 
	// progress, slider, list, tree, and tab controls.
	// Adding the ICC_DATE_CLASSES flag is required to initialize the 
	// date time picker and month calendar controls.
	// Add additional flags to support additoinal controls not mentioned above.
	AtlInitCommonControls(ICC_DATE_CLASSES);

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	::CoUninitialize();

	return nRet;
}

HINSTANCE GetInst()
{
	return _Module.GetModuleInstance();
}
extern TCHAR g_szJobID[32];
#ifdef UNDER_CE
DWORD GetPrivateProfileString(LPCTSTR lpAppName,LPCTSTR lpKeyName,
	LPCTSTR lpDefault,
	LPTSTR lpReturnedString,
	DWORD nSize,
	LPCTSTR lpFileName);
#endif
static const char GPSInfoLoopText[]="[Head]\r\nType=1\r\nMode=0\r\nBlocking=0\r\n";
static const char szGPSOutPath[] = "\\My Documents\\tb-navi.remote\\GPSInfoTryOnce.out";
static const char szGPSOutPath2[] = "\\My Documents\\tb-navi.remote\\GPSInfoTryOnce+z5e3.out";
static const char szJobGPSDAT[] = "\\DataOverIP\\Out\\GPSInfo.job";
void SendGPSInfo()
{
	
	TCHAR strFind1[128],strFind2[128];;
	if(wcslen(g_szJobID)==0) return;
	mbstowcs(strFind1,szGPSOutPath,strlen(szGPSOutPath)+1);
	DeleteFile(strFind1);
	mbstowcs(strFind2,szGPSOutPath2,strlen(szGPSOutPath2)+1);
	DeleteFile(strFind2);
	FILE * f = fopen("\\My Documents\\tb-navi.remote\\GPSInfoTryOnce.in" , "wb");
	if(!f)
	{
		CreateDirectory(L"\\My Documents\\tb-navi.remote",NULL);
	    f = fopen("\\My Documents\\tb-navi.remote\\GPSInfoTryOnce.in" , "wb");
	}
	if(f)
	{
		TCHAR szDistanceToTarget[32],szTimeToTarget[32],szTimestamp[32],szTarget[128],szRoadmatched[128];
		fwrite(GPSInfoLoopText,1,strlen(GPSInfoLoopText),f);
		fclose(f);
		int count=0;
		do{
			//Sleep(1000);
			HANDLE handle=ghEventExit;
			DWORD timeout =1000;
			int ret = WaitForSingleObject(handle,timeout);
			if(ret==WAIT_OBJECT_0) break;

			WIN32_FIND_DATA fndData;
			HANDLE hFind;
			TCHAR *strFind=0;
			hFind = FindFirstFile(strFind1, &fndData);	
			if(hFind==INVALID_HANDLE_VALUE)
			{
				hFind = FindFirstFile(strFind2, &fndData);
				if(hFind!=INVALID_HANDLE_VALUE)
				{
					strFind=strFind2;
				}
			}else
			{
				strFind = strFind1;
			}
			if (INVALID_HANDLE_VALUE != hFind) 	
			{
				GetPrivateProfileString(L"NavigationInformation",L"DistanceToTarget",L"",szDistanceToTarget,31,strFind);
				GetPrivateProfileString(L"NavigationInformation",L"RoadmatchedPosGeodecimal",L"",szRoadmatched,128,strFind);
				GetPrivateProfileString(L"NavigationInformation",L"TimeToTarget",L"",szTimeToTarget,31,strFind);
				GetPrivateProfileString(L"NavigationInformation",L"Target",L"",szTarget,128,strFind);
				//GetPrivateProfileString(L"Head",L"Id",L"",szId,128,strFind);
				GetPrivateProfileString(L"Head",L"Timestamp",L"",szTimestamp,128,strFind);
				f = fopen(szJobGPSDAT , "wb");
				if(f)
				{
					//fmt =  L"<type:=%s><uniqueid:=%s><jobid:=%s><name:=%s><status:=%d><text:=%s><ts:=%04d-%02d-%02d %02d:%02d:%02d><lat:=%s><lon:=%s>\r\n" ;
					CString str;
					str.Format(L"<jobid:=%s><DistanceToTarget:=%s><TimeToTarget:=%s><RoadmatchedPosGeodecimal=%s><Target=%s><Timestamp:=%s>\r\n" ,
						g_szJobID, szDistanceToTarget,szTimeToTarget,szRoadmatched,szTarget,szTimestamp);
					int len = str.GetLength();
					char * pbstr = new char[len+1];
					wcstombs( pbstr,(LPCTSTR) str, len+1);
					fwrite( pbstr ,1 , len ,f );
					delete pbstr;
					//fprintf(f,"<Id:=%s><jobid:=%s><DistanceToTarget:=%s><TimeToTarget:=%d><Timestamp:=%s>\r\n" ,szId, szDistanceToTarget,szTimeToTarget,szTimestamp);
					fclose(f);
				}
				FindClose(hFind);
				break;
			}
			count++;
		}while(count<10) 	;
	}

}
static DWORD WINAPI TimerTask(void*para )
{
	//write reset command to IN folder
	//wait for back
	//get data.
	HWND hWnd = (HWND) para;

	HANDLE handle;
//	HANDLE hChange = FindFirstChangeNotification(wcPath,FALSE,fMask);
	DWORD ret = 0;
	int timeout =1000*(150);
	
	while(1){
		//ret = WaitForSingleObject(hChange,-1);
		handle=ghEventExit;
		
		ret = WaitForSingleObject(handle,timeout);
		if(ret==WAIT_OBJECT_0){
			//exit
			break;
		}
		SendGPSInfo();
	}
	
	return 0;
}

static DWORD WINAPI BTHTask(void*para )
{
	PROCESS_INFORMATION pinfo = {0};
	DWORD dwExitCode = 0;
	TCHAR szApp[64];
	wsprintf(szApp,L"\\Flashdisk\\bthserver.exe");

	do{
		if(!::CreateProcess(szApp,NULL,NULL,NULL,FALSE,0,NULL,NULL,NULL,&pinfo)) 
			break;
		int ret;
		HANDLE handles[2];
		handles[0]= pinfo.hThread;
		handles[1]= ghEventExit;
		ret = WaitForMultipleObjects(2, handles,FALSE,INFINITE);
		if( ret== WAIT_OBJECT_0+1 )//::WaitForMultipleObjects(handlesd,FALSE,INFINITE) != WAIT_FAILED)   
		{
			HANDLE hExit = CreateEvent(NULL,TRUE,FALSE,L"bthserver.exit");
			SetEvent(hExit);
			CloseHandle(hExit);
			GetExitCodeProcess(pinfo.hProcess,&dwExitCode);
			CloseHandle(pinfo.hProcess);
			break;
		}else if( ret== WAIT_OBJECT_0 )
		{
			GetExitCodeProcess(pinfo.hProcess,&dwExitCode); 
			CloseHandle(pinfo.hProcess);	
		}else break;
	}while(TRUE);
	return dwExitCode;

}

