# nmake -f makefile.msvc
# Arguments:
# CFG=dbg|rel (default: dbg)


CC = cl.exe



LD = link.exe
LIBPATH = "C:\Program Files (x86)\Windows CE Tools\SDKs\CEPCSDK\lib\x86"
LDFLAGS = $(LDFLAGS) /nologo /DEBUG
LDFLAGS = $(LDFLAGS) /STACK:3145728 
LDFLAGS = /INCREMENTAL /NOLOGO /DLL /NOENTRY /MANIFEST:NO /NODEFAULTLIB:"oldnames.lib" /STACK:65536,4096 /LIBPATH:$(LIBPATH) /DYNAMICBASE:NO /MACHINE:X86 /ERRORREPORT:PROMPT coredll.lib corelibc.lib
RCFLAGS = /i.. /d "_WIN32_WCE=0x500" /d "UNDER_CE" /d "_UNICODE" /d "UNICODE"   /l 0x409 /I $(O)
APPNAME=CN828Job

O=resdll.cepc
ENGLISH_RES = $(O)\$(APPNAME)_en.res
ENGLISH_DLL = $(O)\$(APPNAME)_en.dll
SPANISH_RES = $(O)\$(APPNAME)_sp.res
SPANISH_DLL = $(O)\$(APPNAME)_sp.dll
FRENCH_RES = $(O)\$(APPNAME)_fr.res
FRENCH_DLL = $(O)\$(APPNAME)_fr.dll
ITALIAN_RES = $(O)\$(APPNAME)_it.res
ITALIAN_DLL = $(O)\$(APPNAME)_it.dll
TURKISCH_RES = $(O)\$(APPNAME)_tu.res
TURKISCH_DLL = $(O)\$(APPNAME)_tu.dll
all: $(ENGLISH_DLL) $(SPANISH_DLL) $(FRENCH_DLL) $(ITALIAN_DLL) $(TURKISCH_DLL) 


rebuild: clean all

clean: force
	-rmdir /S /Q $(O)


$(O): force
	@if not exist $(O) mkdir $(O)

$(ENGLISH_RES): english.rc
	rc $(RCFLAGS) /fo$(ENGLISH_RES) english.rc

$(ENGLISH_DLL): $(ENGLISH_RES)
	link /OUT:$(ENGLISH_DLL) $(ENGLISH_RES) $(LDFLAGS)
	del $(ENGLISH_RES)


$(SPANISH_RES): spanish.rc
	rc  $(RCFLAGS) /fo$(SPANISH_RES) spanish.rc

$(SPANISH_DLL): $(SPANISH_RES)
	link /OUT:$(SPANISH_DLL) $(SPANISH_RES) $(LDFLAGS)
	del $(SPANISH_RES)

$(FRENCH_RES): FRENCH.rc
	rc  $(RCFLAGS) /fo$(FRENCH_RES) FRENCH.rc

$(FRENCH_DLL): $(FRENCH_RES)
	link /OUT:$(FRENCH_DLL) $(FRENCH_RES) $(LDFLAGS)
	del $(FRENCH_RES)
	
$(ITALIAN_RES): ITALIAN.rc
	rc  $(RCFLAGS) /fo$(ITALIAN_RES) ITALIAN.rc

$(ITALIAN_DLL): $(ITALIAN_RES)
	link /OUT:$(ITALIAN_DLL) $(ITALIAN_RES) $(LDFLAGS)
	del $(ITALIAN_RES)
	
$(TURKISCH_RES): TURKISCH.rc
	rc $(RCFLAGS) /fo$(TURKISCH_RES) TURKISCH.rc

$(TURKISCH_DLL): $(TURKISCH_RES)
	link /OUT:$(TURKISCH_DLL) $(TURKISCH_RES) $(LDFLAGS)
	del $(TURKISCH_RES)
	
	
force: ;