#pragma once
#include "PublicCtrl.h"
#include <atlframe.h>
#include <atlwin.h>
#include "cpss_messageSend.h"
#define  WM_LEAVE WM_USER+11
#define WM_USER_INDICATE WM_USER+1
#define WM_USER_CONFIG_CHANGED WM_USER+2
#define WM_USER_UPDATE_LIST WM_USER+3
#define WM_NCCALCSIZE 0x0083
#define CPSSCOM_HANDLER 	COMMAND_HANDLER


#define LIST_SPACE 5
#ifndef __VIR_LIST__
class CMyListCtrl : public CWindowImpl<CMyListCtrl, CListViewCtrl>, public CCustomDraw<CMyListCtrl>
{
    BEGIN_MSG_MAP(CMyListCtrl)
        CHAIN_MSG_MAP_ALT(CCustomDraw<CMyListCtrl>, 1)
		MESSAGE_HANDLER(WM_NCCALCSIZE ,OnNcCalcSize)
		MESSAGE_HANDLER(WM_ERASEBKGND ,OnErasebkgnd)
        DEFAULT_REFLECTION_HANDLER()
    END_MSG_MAP()

 
    DWORD OnPrePaint(int idCtrl, LPNMCUSTOMDRAW lpNMCD);
    DWORD OnItemPrePaint(int idCtrl, LPNMCUSTOMDRAW lpNMCD);
	LRESULT OnNcCalcSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
 	bool HideScrollBar(int);

#if (_WIN32_IE >= 0x0400)
	DWORD OnSubItemPrePaint(int /*idCtrl*/, LPNMCUSTOMDRAW /*lpNMCustomDraw*/);
	LRESULT OnErasebkgnd(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled){
		bHandled = 1;
		return 1;
	}
#endif // (_WIN32_IE >= 0x0400)
private:
	HBITMAP Line1;
//	HBITMAP Line2;
//	HBITMAP Line3;
//	HBITMAP Line4;
//	HBITMAP Line5;
	HBITMAP LineS;

public:
	HBITMAP hListBK;
	CMyListCtrl() {
		Line1 = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINE1);
//		Line2 = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINE2);
//		Line3 = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINE3);
//		Line4 = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINE4);
//		Line5 = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINE5);
		LineS = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINES);
		hListBK= SHLoadImageResource (NULL,  IDB_BK_LISTE_PART);
	}
	~CMyListCtrl() {
		DeleteObject(Line1);
//		DeleteObject(Line2);
//		DeleteObject(Line3);
//		DeleteObject(Line4);
//		DeleteObject(Line5);
		DeleteObject(LineS);
		DeleteObject(hListBK);
	}


};
#else

class CMyListCtrl : public CVirSimpleListCtrl
{
public :
	CMyListCtrl():CVirSimpleListCtrl()
	{

	}
	virtual DWORD DrawItem(HDC  , int nLine,CRect& rcPaint);
	virtual void SortItems(int nSort) ;
	
};
#endif

class CpssListBox: public VButtonWnd //public CWindowImpl<CpssListBox>
{
public:
    	//DECLARE_WND_CLASS(NULL)
		enum { IDD = IDD_HELP };    //DECLARE_WND_CLASS(NULL)
		CpssListBox(HWND Wnd,int Style,int Type):VButtonWnd(IDB_BK_LISTE,IDB_ICON_AUFT2,ICON_POS)
    	{
		    //MsgSend=NULL;
		    ListBoxStyle  =Style; //
                                //  
		    ListBoxType=Type;
			m_pHwnd=Wnd;

			/*LOGFONT lf;
			::GetObject(::GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), &lf);
			lf.lfWeight = FW_BOLD;
			lf.lfHeight = 20;
			lstrcpy(lf.lfFaceName ,__FONT_BOLD__);
			m_hfont = ::CreateFontIndirect(&lf);*/
			m_hfont = 0;
		}

		~CpssListBox()
		{
			//ClearDataList();

			if(m_hfont)
			::DeleteObject(m_hfont);
	
		}
LRESULT OnUserUpdateList(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
void AddOneItem(TCHAR* cFileName,FILETIME* ptm,DWORD state=-1);
void DeleteJobItem(struct __JobState* pState );
void ReflashJobItem(struct __JobState* pState );
CMyListCtrl   m_ListBox;
//virtual void EnableScrollBtn(BOOL bErase=TRUE);
private:
        int ListBoxStyle,ListBoxType;  

		
		HFONT m_hfont;
		CpssScrollBar   cScrollBar;
		
//		cMsgView        *m_MsgView;
       // CpssMsgSend     *m_MsgSend;
        //int             nItem;
		//HFONT           m_hfont;
		//MailInfo        Email_Info;
		//SMSInfo         SMSItem;
		//DATAInfo        DATAItem;
		//bool            b_DetectSDCard;
		//int             PtList;
		//int             TotalList;
		//int             MultiList;
		//CMyBitmap     m_BK;
	virtual void OnPaintExt(HDC hDC,CRect& rcPaint);
public:
		HWND           m_pHwnd;
	    BEGIN_MSG_MAP(CpssListBox)
        //MESSAGE_HANDLER(WM_CREATE     ,OnCreate)
	    MESSAGE_HANDLER(WM_INITDIALOG     ,OnInitDialog) 
		MESSAGE_HANDLER(WM_ERASEBKGND ,OnErasebkgnd)
        MESSAGE_HANDLER(WM_PAINT      ,OnPaint) 
		MESSAGE_HANDLER(WM_DESTROY    ,OnDestroy)
		MESSAGE_HANDLER(IDB_LISTSCOLL_BK ,OnScroll)
		MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove) 
		MESSAGE_HANDLER(WM_TIMER ,OnTimer)
		MESSAGE_HANDLER(WM_USER_CHANGE_SKIN,	OnChangeSkin)
		MESSAGE_HANDLER(WM_USER_CONFIG_CHANGED ,OnConfigChanged)	
		MESSAGE_HANDLER(WM_ACTIVATE ,OnActivateApp)
    	CPSSCOM_HANDLER(ID_LIST_READ, BN_CLICKED,OnEditMsg)
		CPSSCOM_HANDLER(ID_LIST_SEND, BN_CLICKED,OnDetailMsg)
		CPSSCOM_HANDLER(ID_LIST_DEL , BN_CLICKED,OnDeleMsg)
		CPSSCOM_HANDLER(ID_START , BN_CLICKED,OnStart)
		CPSSCOM_HANDLER(ID_CANCEL   , BN_CLICKED,OnCancelMsg)
		CPSSCOM_HANDLER(ID_LIST_GEHEZU   , BN_CLICKED,OnGehezu)
		CPSSCOM_HANDLER(IDB_btn_statusboard   , BN_CLICKED,OnStatusBoard)
		NOTIFY_HANDLER(ID_LISTVIEW_ONKEY, LVN_ITEMCHANGED, OnItemChanged); //NM_CLICK 
		MESSAGE_HANDLER(WM_LBUTTONDOWN,	OnLButtonDown);
		MESSAGE_HANDLER(WM_LBUTTONUP,	OnLButtonUp);
		REFLECT_NOTIFICATIONS()	
		END_MSG_MAP()

protected:
	//LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnInitDialog /*OnCreate*/(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	//LRESULT OnErasebkgnd(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	//LRESULT OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/);
  	
	LRESULT OnScroll(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnItemChanged( int wParam, LPNMHDR /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnConfigChanged(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnChangeSkin(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnEditMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
LRESULT OnGehezu(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
LRESULT OnStatusBoard(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
LRESULT OnStart(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnDetailMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnDeleMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnActivateApp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/) ;
public:
    //List Function;
	void CreateList(void);
	void ClearDataList(void);
    void DataList(void);
	void SaveJobStates(void);
	int search_order(TCHAR* order);
//	void MsgString(TCHAR *Ori_Str,TCHAR *Dest_Str,int StrLen);

};


#ifdef UNDER_CE

#define FLASH_JOB_DIR TEXT(APP_ROOT)  L"\\Jobs"
#define INI_FOLDER    "\\Storage Card"  //"\\Storage Card"
#define SDCARD_JOB_DIR L"\\Storage Card\\Jobs"

#else
#define FLASH_JOB_DIR L"c:\\tmp\\Jobs"
#define INI_FOLDER    "c:\\tmp\\Storage Card"
#define SDCARD_JOB_DIR L"c:\\tmp\\Storage Card\\Jobs"

#endif
#define __LOCK__()	WaitForSingleObject(ghMutex,INFINITE) 
#define __unLOCK__()	ReleaseMutex(ghMutex)
#define JOBID_LEN 64
extern BOOL g_bActiveDel,g_bAutoDel;
extern int g_bSort;
extern BOOL g_bLupe,g_bAnme;
extern DWORD g_dwMode ,g_dwExtApp, g_dwAlarm;
#define NUM_INFO 10 //6


typedef struct __UNTER_INFO_t
{	
	//BOOL bParsed;
	CSimpleArray<std::string>  m_arrText ;
	CSimpleArray<int>  m_arrFlag[2] ;
}UNTER_INFO_t;

struct __JobState{
	int  dwJobState;
	DWORD fFlag;
	TCHAR szJobFile[JOBID_LEN];
	FILETIME ftime;
	FILETIME fInTime;
	TCHAR order[JOBID_LEN];//DWORD  order;// for search
	DWORD reminder;
	int timer; 
	int bHasPOI;
	//int nTargetCount;
	int nAllCount;
	TCHAR* returns[NUM_INFO];
	CSimpleArray<UNTER_INFO_t> listUInfo;
	int hasAttchments;
 
};

#define FLAG_TYPE_MASK	  0x3
#define FLAG_INI_VALID    4
#define FLAG_PAUSE		    8

#define FLAG_STARTED		    16
enum
{
	JOB_TOUR,
	JOB_SINGLE,
	JOB_MULTI
};

enum
{
	SD_UNKNOWN,
	SD_INSERTED,
	SD_REMOVED
};
BOOL MarkJobState(struct __JobState * pState, int state);
int send_job_status( struct __JobState*  pState, TCHAR* text,int newstat,int ex=-2,int wizardstat=0x5555,char *szext=NULL,int nPosition=-1);
void erase_job(struct __JobState * pState);
void initINIFlag();
UINT getStateBitmap2Id(struct __JobState* pState );
#define USER_UPDATE_LIST 1
#define USER_DEL_ITEM	2
#define USER_REFRESH_ITEM 3
#define USER_REFRESH_ALL 4
#define USER_CFG_CHANGED 5
typedef struct CONTAINER_t
{
	int pnum,cnum;
	int rate;
	FILETIME ftime;
}CONTAINER;

typedef struct SUBORDER_t
{
	int num;
	int flag;
	int rate;
}SUBORDER;

typedef struct __MYPOS
{
	float fLat,fLon;
	BOOL bReached;
	BOOL bIngored;
	int  nRealPos;
	//CSimpleArray<SUBORDER> listContainer;
	float dwRadius;
	CString strAttachment;
}MYPOS;
typedef struct SavedNaviRecord
{
	CString strJob;
	BOOL    bJobParsed;
	CSimpleArray<MYPOS> listPos,listPoi;
	int  nSelectPos;
	int  nCurrentReached,nReachedPoi;
	int lastReachedPos;
	//CString strAttachment;
}SavedNaviRecord_t;
void getMinRadius(SavedNaviRecord_t * st); //void getMinRadius(CSimpleArray<MYPOS> & list);
void send_job_pos_status(struct __JobState * pState, int pos,TCHAR* szSel,int newstatus);
void send_Anfahrt(struct __JobState * pState, int pos);
struct __JobState* peekJobState(TCHAR* jobFile);
extern BOOL g_bManualStatus ;
int GetLastReachedPos(SavedNaviRecord_t& st );
void PurgeAll();